__author__ = 'vandermonde'

import numpy as np
import random
from hebbLearn import *

X = np.zeros((10, 8, 8), np.int32)
X[0] = [[-1, -1,-1, -1, -1, -1, -1, 1],
        [-1, -1, 1,  1,  1, -1, -1, 1],
        [-1, -1, 1,  1,  1, -1, -1, 1],
        [-1, -1, 1,  1,  1, -1, -1, 1],
        [-1, -1, 1,  1,  1, -1, -1, 1],
        [-1, -1, 1,  1,  1, -1, -1, 1],
        [-1, -1, 1,  1,  1, -1, -1, 1],
        [-1, -1,-1, -1, -1, -1, -1, 1]]

X[1] = [[1, 1, -1, -1, -1, 1, 1, 1],
        [1, 1, -1, -1, -1, 1, 1, 1],
        [1, 1,  1, -1, -1, 1, 1, 1],
        [1, 1,  1, -1, -1, 1, 1, 1],
        [1, 1,  1, -1, -1, 1, 1, 1],
        [1, 1,  1, -1, -1, 1, 1, 1],
        [1, 1,  1, -1, -1, 1, 1, 1],
        [1, 1,  1, -1, -1, 1, 1, 1]]

X[2] = [[1, -1, -1, -1, -1, -1, -1, -1],
        [1, -1, -1, -1, -1, -1, -1, -1],
        [1,  1,  1,  1,  1,  1, -1, -1],
        [1, -1, -1, -1, -1, -1, -1, -1],
        [1, -1, -1, -1, -1, -1, -1, -1],
        [1, -1, -1, 1, 1, 1, 1, 1],
        [1, -1, -1, -1, -1, -1, -1, -1],
        [1, -1, -1, -1, -1, -1, -1, -1]]

X[3] = [[1,   1,  -1,  -1, -1, -1, -1, 1],
        [1,   1,  -1,  -1, -1, -1, -1, 1],
        [1,   1,   1,   1,  1, -1, -1, 1],
        [1,   1,   1,  -1, -1, -1, -1, 1],
        [1,   1,   1,  -1, -1, -1, -1, 1],
        [1,   1,   1,   1,  1, -1, -1, 1],
        [1,   1,  -1,  -1, -1, -1, -1, 1],
        [1,   1,  -1,  -1, -1, -1, -1, 1]]

X[4] = [[1,  -1, -1,  1,  1, -1, -1, 1],
        [1,  -1, -1,  1,  1, -1, -1, 1],
        [1,  -1, -1,  1,  1, -1, -1, 1],
        [1,  -1, -1, -1, -1, -1, -1, 1],
        [1,  -1, -1, -1, -1, -1, -1, 1],
        [1,   1,  1,  1,  1, -1, -1, 1],
        [1,   1,  1,  1,  1, -1, -1, 1],
        [1,   1,  1,  1,  1, -1, -1, 1]]

X[5] = [[1, -1, -1, -1, -1, -1, -1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1],
        [1, -1, -1, 1, 1, 1, 1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1],
        [1,  1,  1,  1,  1, -1, -1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1]]

X[6] = [[-1, -1, -1, -1, -1, -1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1],
        [-1, -1, 1, 1, 1, 1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1],
        [-1, -1,  1,  1, -1, -1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1]]

X[7] = [[1, 1, -1, -1, -1, -1, -1, -1],
        [1, 1, -1, -1, -1, -1, -1, -1],
        [1, 1,  1,  1,  1,  1, -1, -1],
        [1, 1,  1,  1, -1, -1, -1, -1],
        [1, 1,  1, -1, -1, -1, 1, 1],
        [1, 1,  1, -1, -1, 1, 1, 1],
        [1, 1,  1, -1, -1, 1, 1, 1],
        [1, 1,  1, -1, -1, 1, 1, 1]]

X[8] = [[1, 1, 1, 1, 1, 1, 1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1],
        [1, -1,  1,  1,  1,  1, -1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1],
        [1, -1,  1,  1,  1,  1, -1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1]]

X[9] = [[1, -1, -1, -1, -1, -1, -1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1],
        [1, -1, -1,  1,  1, -1, -1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1],
        [1, -1, -1, -1, -1, -1, -1, 1],
        [1,  1,  1,  1,  1,  1, -1, 1],
        [1,  1, -1, -1, -1, -1, -1, 1],
        [1,  1, -1, -1, -1, -1, -1, 1]]
X=X*(-1)


F = np.zeros((10, 8, 8), np.int32)
F[0] = [[1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, -1, -1, -1, -1, 1, 1],
        [1, 1, -1, -1, -1, -1, 1, 1],
        [1, 1, -1, -1, -1, -1, 1, 1],
        [1, 1, -1, -1, -1, -1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1]]

F[1] = [[-1, -1, 1, 1, 1, -1, -1, -1],
        [-1, -1, 1, 1, 1, -1, -1, -1],
        [-1, -1, -1, 1, 1, -1, -1, -1],
        [-1, -1, -1, 1, 1, -1, -1, -1],
        [-1, -1, -1, 1, 1, -1, -1, -1],
        [-1, -1, -1, 1, 1, -1, -1, -1],
        [-1, -1, -1, 1, 1, -1, -1, -1],
        [-1, -1, -1, 1, 1, -1, -1, -1]]

F[2] = [[1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, -1, -1, -1, -1, -1, -1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1]]


F[3] = [[-1, 1, 1, 1, 1, 1, 1, 1],
        [-1, 1, 1, 1, 1, 1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1],
        [-1, -1, 1, 1, 1, 1, 1, 1],
        [-1, -1, 1, 1, 1, 1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1],
        [-1, 1, 1, 1, 1, 1, 1, 1],
        [-1, 1, 1, 1, 1, 1, 1, 1]]

F[4] = [[1, 1, -1, -1, -1, -1, 1, 1],
        [1, 1, -1, -1, -1, -1, 1, 1],
        [1, 1, -1, -1, -1, -1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1]]

F[5] = [[1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, -1, -1, -1, -1, -1, -1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1]]

F[6] = [[1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, -1, -1, -1, -1, -1, -1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, -1, -1, -1, -1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1]]

F[7] = [[1, 1, 1, 1, 1, 1, 1, 1],
        [1, 1, 1, 1, 1, 1, 1, 1],
        [-1, -1, -1, -1, -1, -1, 1, 1],
        [-1, -1, -1, 1, 1, 1, 1, 1],
        [-1, -1, 1, 1, 1, -1, -1, -1],
        [-1, -1, 1, 1, -1, -1, -1, -1],
        [-1, -1, 1, 1, -1, -1, -1, -1],
        [-1, -1, 1, 1, -1, -1, -1, -1]]

F[8] = [[-1, -1, -1, -1, -1, -1, -1, -1],
        [-1, 1, 1, 1, 1, 1, 1, -1],
        [-1, 1, -1, -1, -1, -1, 1, -1],
        [-1, 1, 1, 1, 1, 1, 1, -1],
        [-1, 1, 1, 1, 1, 1, 1, -1],
        [-1, 1, -1, -1, -1, -1, 1, -1],
        [-1, 1, 1, 1, 1, 1, 1, -1],
        [-1, -1, -1, -1, -1, -1, -1, -1]]

F[9] = [[1, 1, 1, 1, 1, 1, 1, -1],
        [1, 1, 1, 1, 1, 1, 1, -1],
        [1, 1, -1, -1, -1, -1, 1, -1],
        [1, 1, 1, 1, 1, 1, 1, -1],
        [1, 1, 1, 1, 1, 1, 1, -1],
        [-1, -1, -1, -1, -1, -1, 1, -1],
        [-1, 1, 1, 1, 1, 1, 1, -1],
        [-1, 1, 1, 1, 1, 1, 1, -1]]

O = X.reshape(10, 64)
T = F.reshape(10, 64)

# for i in range (10):
#     for j in range(8):
#         strr = ""
#         for k in range(8):
#             if T[i, j*8 + k] == 1:
#                 strr = strr + "# "
#             else:
#                 strr = strr + "0 "
#
#         print strr
#     print "\n\n"
#
#
# print "\n\n***************************************************"
#
#
# for i in range (10):
#     for j in range(8):
#         strr = ""
#         for k in range(8):
#             if X[i, j, k] == 1:
#                 strr = strr + "# "
#             else:
#                 strr = strr + "0 "
#
#         print strr
#     print "\n\n"

############################# DATA READY #########################


def hopfieldFind(w, v):
    """
    :param w: D*D matrix of weights (ndarray)
    :param v: D*1 matrix (ndarray)
    :return: D*1 matrix (ndarray)
    """

    D = v.shape[0]
    order = range(D)
    y = v.copy()

    converged = False
    while(not converged):
        converged = True
        random.shuffle(order)
        for i in order:
            yIn = v[i, :] + np.matmul(w[:, i][np.newaxis].reshape(1, D), y)
            if yIn > 0:
                yIn = 1
            elif yIn < 0:
                yIn = 0
            else:
                yIn = y[i, :]
            if(yIn != y[i, :]):
                # print("change in " + str(i) + "from: " + str(y[i, :]) + "to: " + str(yIn))
                converged = False
            y[i,:] = yIn
    # print y
    return y

weights = hebbAssociativeLearn(O[:4, :], O[:4, :], True)

# print weights.shape
# print weights
count01 = 0
count02 = 0
count12 = 0
for i in range(64):
    if O[0, i] != O[1, i]:
        count01 += 1
    if O[0, i] != O[2, i]:
        count02 += 1
    if O[2, i] != O[1, i]:
        count12 += 1

print 0,1, count01
print 0,2, count02
print 2,1, count12

for i in range(O.shape[0]):
    for j in range(O.shape[1]):
        if O[i, j] == -1:
            O[i, j] = 0
        if T[i, j] == -1:
            T[i, j] = 0

for nom in range(3):
    tofind = O[nom][np.newaxis].reshape(64, 1)
    makeNoisy(tofind, 0.2)
    res = hopfieldFind(weights, tofind)

    for i in range(8):
        strr = ""
        for j in range(8):
            if res[i*8 + j, 0] == 1:
                strr += "# "
            else:
                strr += "0 "
        print strr
    print "\n\n"